#pragma semicolon 1
#pragma newdecls required

#include <sdktools>
#include <vip_core>
#include <clientprefs>

#define pl(%0) for(int %0 = 1; %0 <= MaxClients; ++%0) if(IsClientInGame(%0))

public Plugin myinfo =
{
	name = "[VIP] Halo/Нимб",
	author = "R1KO & Pheonix (˙·٠●Феникс●٠·˙), ( rewritten Nek.'a 2x2 | ggwp.site )",
	version = "1.1.3",
	url = "zizt.ru"
};

#define VIP_HALO_M	"HALO_M"
#define VIP_HALO	"HALO"

int g_iClientColor[MAXPLAYERS+1][4],
	g_BeamSprite,
	g_HaloSprite;

VIP_ToggleState g_bHasAura[MAXPLAYERS+1];
bool bEnableInvis;

Handle g_hKv,
	g_hTimer[MAXPLAYERS+1],
	g_hmenu,
	g_hCookie;

public void OnPluginStart()
{
	ConVar cvar;
	cvar = CreateConVar("sm_vip_halo_invise", "1", "1 Включить только для своей команды, 0 отображение для всех", _, true, _, true, 1.0);
	cvar.AddChangeHook(CVarChanged_Enable);
	bEnableInvis = cvar.BoolValue;
	g_hCookie = RegClientCookie("VIP_HALO", "VIP_HALO", CookieAccess_Public);
	AutoExecConfig(true, "halo", "vip");
}

public void CVarChanged_Enable(ConVar CVar, const char[] oldValue, const char[] newValue){bEnableInvis = CVar.BoolValue;}

public void OnMapStart()
{
	g_BeamSprite = PrecacheModel("materials/sprites/blueflare1.vmt");
	g_HaloSprite = PrecacheModel("materials/sprites/glow08.vmt");
	char buffer[256];
	if (g_hKv != INVALID_HANDLE) CloseHandle(g_hKv);
	g_hKv = CreateKeyValues("Aura_n_Colors");
	BuildPath(Path_SM, buffer, 256, "data/vip/modules/halo_colors.ini");
	if (!FileToKeyValues(g_hKv, buffer)) SetFailState("Couldn't parse file %s", buffer);
	g_hmenu = CreateMenu(AuraMenuHandler);
	SetMenuExitBackButton(g_hmenu, true);
	SetMenuTitle(g_hmenu, "Цвет нимба\n ");
	KvRewind(g_hKv);
	if (KvGotoFirstSubKey(g_hKv))
	{
		do
		{
			if (KvGetSectionName(g_hKv, buffer, 256))
			{
				AddMenuItem(g_hmenu, buffer, buffer);
			}
		}
		while (KvGotoNextKey(g_hKv));
	}
	KvRewind(g_hKv);
}

public void VIP_OnVIPLoaded()
{
	VIP_RegisterFeature(VIP_HALO_M, _, SELECTABLE, Open_HALO, OnDisplayItem, OnDrawItem);
	VIP_RegisterFeature(VIP_HALO, BOOL, _, ToggleItemCallback, OnDisplayItem_f);
}

void GetRGBAFromString(char[] sBuffer, int iColor[4])
{
	char sBuffers[4][4];
	ExplodeString(sBuffer, " ", sBuffers, sizeof(sBuffers), sizeof(sBuffers[]));
	iColor[0] = StringToInt(sBuffers[0]);
	iColor[1] = StringToInt(sBuffers[1]);
	iColor[2] = StringToInt(sBuffers[2]);
	iColor[3] = StringToInt(sBuffers[3]);
}

public void VIP_OnVIPClientLoaded(int iClient)
{
	if(VIP_IsClientFeatureUse(iClient, VIP_HALO))
	{
		g_bHasAura[iClient] = ENABLED;
		char sInfo[64];
		GetClientCookie(iClient, g_hCookie, sInfo, 64);
		if(sInfo[0])
		{
			GetRGBAFromString(sInfo, g_iClientColor[iClient]);
			return;
		}
	}
	for(int i=0; i < 4; i++) g_iClientColor[iClient][i] = 255;
}

public bool Open_HALO(int iClient, const char[] sFeatureName)
{
	DisplayMenu(g_hmenu, iClient, MENU_TIME_FOREVER);
	return false;
}

public int AuraMenuHandler(Handle hMenu, MenuAction action, int iClient, int Item)
{
	switch(action)
	{
		case MenuAction_Cancel:
		{
			if(Item == MenuCancel_ExitBack) VIP_SendClientVIPMenu(iClient);
		}
		case MenuAction_Select:
		{
			char sInfo[64];
			GetMenuItem(hMenu, Item, sInfo, 64);
			KvRewind(g_hKv);
			if (KvJumpToKey(g_hKv, sInfo, false))
			{
				KvGetColor(g_hKv, "color", g_iClientColor[iClient][0],  g_iClientColor[iClient][1],  g_iClientColor[iClient][2],  g_iClientColor[iClient][3]);
				KvRewind(g_hKv);
				PrintToChat(iClient, " \x03Вы изменили цвет нимба на \x04%s", sInfo);
				FormatEx(sInfo, 64, "%i %i %i %i", g_iClientColor[iClient][0],  g_iClientColor[iClient][1],  g_iClientColor[iClient][2],  g_iClientColor[iClient][3]);
				SetClientCookie(iClient, g_hCookie, sInfo);
			}
			else PrintToChat(iClient, "Failed to use \"%s\"!.", sInfo);
			DisplayMenu(g_hmenu, iClient, MENU_TIME_FOREVER);
		}
	}
}

public int OnDrawItem(int iClient, const char[] sMenuOptionName, int style)
{
	return VIP_GetClientFeatureStatus(iClient, VIP_HALO) != ENABLED ? ITEMDRAW_DISABLED:style;
}

public bool OnDisplayItem(int iClient, const char[] sFeatureName, char[] sDisplay, int maxlen)
{
	strcopy(sDisplay, maxlen, "Цвет нимба");
	return true;
}

public Action ToggleItemCallback(int iClient, const char[] sFeatureName, VIP_ToggleState OldStatus, VIP_ToggleState &NewStatus)
{
	g_bHasAura[iClient] = NewStatus;
	if(NewStatus == ENABLED) SetClientAura(iClient);
	return Plugin_Continue;
}

public bool OnDisplayItem_f(int iClient, const char[] sFeatureName, char[] sDisplay, int maxlen)
{
	FormatEx(sDisplay, maxlen, "Нимб [%s]", VIP_IsClientFeatureUse(iClient, VIP_HALO) ? "Включено":"Выключено");
	return true;
}

public void OnClientDisconnect(int iClient)
{
	g_bHasAura[iClient] = DISABLED;
	g_hTimer[iClient] = INVALID_HANDLE;
}

public void VIP_OnPlayerSpawn(int iClient, int iTeam, bool bIsVIP)
{
	if(bIsVIP && g_bHasAura[iClient])
	{
		SetClientAura(iClient);
	}
}

int SetClientAura(int iClient)
{
	if(g_hTimer[iClient] == INVALID_HANDLE) g_hTimer[iClient] = CreateTimer(0.1, Timer_Beacon, iClient, TIMER_REPEAT);
}

public Action Timer_Beacon(Handle hTimer, any iClient)
{
	if(IsClientInGame(iClient) && IsPlayerAlive(iClient) && g_bHasAura[iClient] == ENABLED)
	{
		static float fVec[3];
		GetClientAbsOrigin(iClient, fVec);
		fVec[2] += 85;
		TE_SetupBeamRingPoint(fVec, 15.0, 17.0, g_BeamSprite, g_HaloSprite, 0, 15, 0.1, 10.0, 5.0, g_iClientColor[iClient], 10, 0);
		if(!bEnableInvis)
		{
			TE_SendToAll();
		}else
		{
			int iTeam = GetClientTeam(iClient);
			TE_SendTo(iTeam);
		}
		return Plugin_Continue;
	} 
	else
	{
		g_hTimer[iClient] = INVALID_HANDLE;
	}
	return Plugin_Stop;
}
void TE_SendTo(int iTeam)
{
	int[] iClients = new int[MaxClients]; 
	int iGo;
    
	switch(!iGo)
    {
        case 1:
        {
            pl(ply)
            {
                if(GetClientTeam(ply) == iTeam) iClients[iGo++] = ply;
            }
        }
        case 2:
        {
            pl(ply) iClients[iGo++] = ply;
        }
    }

	if(iGo > 0) TE_Send(iClients, iGo);
}